# svelte-api-keys

API Key Generation, Validation, and Rate Limiting for SvelteKit

## Features

✅ Generate secure API keys in Base58 format for easy reading and typing
✅ Avoid accidental bad-words in generated keys (taking homoglyphs into account)
✅ Attach name, description, permissions, and expiry to keys (for self-service)
✅ Validate keys and return info for authorization
✅ Authorize API requests based on validated key permissions
✅ Easy to-implement key storage interface: In-Memory, Firestore, and Redis implementations provided
✅ LRU Cache with TTL ensures low-overhead for high performance APIs
✅ Token-Bucket Rate-limiting of API requests: In-memory, and Redis implementations provided
